'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @file 卸载扩展
 * @author wangyisheng@baidu.com (wangyisheng)
 */

var ora = require('ora');
var fs = require('fs-extra');
var shelljs = require('shelljs');
var path = require('path');

var config = require('./config');
var log = require('../utils/log');

function resolve() {
    var dir = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

    return path.resolve(process.cwd(), dir);
}

module.exports = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(options) {
        var extensionName, extension, npmName, dirName, spinner, recommendFiles, modifyFiles, jsonObject, code;
        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        extensionName = options.name;
                        extension = config.EXTENSION_MAP[extensionName];

                        if (extension) {
                            _context.next = 5;
                            break;
                        }

                        log.fatal(`没有找到名为 ${extensionName} 的 Lavas 扩展`);
                        return _context.abrupt('return');

                    case 5:
                        npmName = extension.npmName, dirName = extension.dirName;
                        spinner = ora('正在卸载扩展...');

                        spinner.start();

                        recommendFiles = void 0;
                        modifyFiles = void 0;
                        _context.prev = 10;
                        _context.next = 13;
                        return fs.readJson(resolve(`extensions/${dirName}/recommend.json`));

                    case 13:
                        jsonObject = _context.sent;

                        recommendFiles = jsonObject.list;
                        modifyFiles = recommendFiles.map(function (file) {
                            return file.replace(/\.recommend\.(\w+)$/, '.$1');
                        });
                        _context.next = 22;
                        break;

                    case 18:
                        _context.prev = 18;
                        _context.t0 = _context['catch'](10);

                        log.fatal(`Lavas 扩展 ${extensionName} 可能已经损坏，请手动删除`);
                        return _context.abrupt('return');

                    case 22:

                        // npm install package
                        console.log('\n');
                        code = shelljs.exec(`npm uninstall ${npmName} --save`).code;

                        if (!(code !== 0)) {
                            _context.next = 27;
                            break;
                        }

                        log.fatal(`npm uninstall ${npmName} 失败`);
                        return _context.abrupt('return');

                    case 27:
                        _context.next = 29;
                        return _promise2.default.all([].concat((0, _toConsumableArray3.default)(recommendFiles.map(function (file) {
                            return fs.remove(resolve(file));
                        })), [
                        // 删除extensions目录中的对应扩展
                        fs.remove(resolve(`extensions/${dirName}`))]));

                    case 29:

                        spinner.stop();

                        log.info('卸载扩展完毕');
                        log.info('为了正确卸载扩展，您还需要修改下列文件以去除对扩展的引用：');
                        modifyFiles.forEach(function (file) {
                            log.info(`* ${file}`);
                        });

                    case 33:
                    case 'end':
                        return _context.stop();
                }
            }
        }, _callee, this, [[10, 18]]);
    }));

    return function (_x2) {
        return _ref.apply(this, arguments);
    };
}();