/**
 * @file 检测新版本
 * @author mj(zoumiaojiang@gmail.com)
 */

'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var semver = require('semver');
var axios = require('axios');
var log = require('./log');

var LAVAS_NPM_REGISTRY = 'https://registry.npmjs.org/lavas';
var UPDATE_TEXT = 'Lavas 有新的版本更新，为了不影响您的使用，请您通过 `npm update -g lavas` 命令更新版本 !';

/**
 * 检测是否需要更新 Lavas 版本
 */
module.exports = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    var packageInfo, lastVersion, curVersion;
    return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
            switch (_context.prev = _context.next) {
                case 0:
                    _context.prev = 0;
                    _context.next = 3;
                    return axios({
                        url: LAVAS_NPM_REGISTRY,
                        timeout: 1000
                    });

                case 3:
                    packageInfo = _context.sent;
                    lastVersion = packageInfo.data['dist-tags'].latest;
                    curVersion = require('../../package.json').version;


                    if (semver.gt(lastVersion, curVersion)) {
                        console.log('\n');
                        log.warn(log.chalk.bold.yellow(UPDATE_TEXT));
                    }

                    _context.next = 11;
                    break;

                case 9:
                    _context.prev = 9;
                    _context.t0 = _context['catch'](0);

                case 11:
                case 'end':
                    return _context.stop();
            }
        }
    }, _callee, this, [[0, 9]]);
}));